package com.mypro.manager;

import com.mypro.constant.Constant;
import com.mypro.model.GamingInfo;
import com.mypro.model.LoadProgress;
import com.mypro.tools.LogTools;


/**
 * Ϸʼ
 * @author Xiloerfan
 *
 */
public class GameInitManager {
	private static GameInitManager manager;
	private boolean initing = true;
	/**
	 * Ƿڳʼ
	 * @return
	 */
	public boolean isIniting(){
		return initing;
	}
	private GameInitManager(){}
	public static GameInitManager getGameInitManager(){
		if(manager == null){
			manager = new GameInitManager();
		}
		return manager;
	}
	public void init(){
		ImageManager.getImageMnagaer().initManager();
		initProgress();
		initGame();//ʼϷ
    	try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	closeProgress();
    	beginGame();
    	initing = false;
	}
	/**
	 * ʼ
	 */
	private void initProgress(){
		while(LoadProgress.getLoadProgress()==null);
		GamingInfo.getGamingInfo().getSurface().putDrawablePic(Constant.LOAD_PROGRESS_LAYER, LoadProgress.getLoadProgress());
	} 
	
	/**
	 * رս
	 */
	private void closeProgress(){
		try{
			if(GamingInfo.getGamingInfo().getSurface()!=null){
				GamingInfo.getGamingInfo().getSurface().removeDrawablePic(Constant.LOAD_PROGRESS_LAYER, LoadProgress.getLoadProgress());
			}
		}catch(Exception e){
			LogTools.doLogForException(e);
		}
	} 
	 /**
     * ʼ
     */
    private void initComponents(){
    	LayoutManager.getLayoutManager().init();
//    	
//    	// ߴť
//    	GamingInfo.getGamingInfo().getSurface().putDrawablePic(Constant.COMPONENTS_LAYER, new GreateGunQualityButton());
//    	// ƽʹť
//    	GamingInfo.getGamingInfo().getSurface().putDrawablePic(Constant.COMPONENTS_LAYER, new LessGunQualityButton());
//    	// ½ǼƷ
//    	GamingInfo.getGamingInfo().getSurface().putDrawablePic(Constant.COMPONENTS_LAYER, new BottomLeftComponent());
//    	// ½Ǽ
//    	GamingInfo.getGamingInfo().getSurface().putDrawablePic(Constant.COMPONENTS_LAYER, new BottomRightComponent());
    }
    
	/**
	 * ʼϷ
	 */
	private void initGame(){
			//ʼ
			this.initComponents();
			//ʼ÷ֹ
			ScoreManager.getScoreManager().init();
			//ʼӹ
			ParticleEffectManager.getParticleEffectManager();
			LoadProgress.getLoadProgress().setProgress(10);
			//ʼڹ
			CannonManager.getCannonManager().init();
			LoadProgress.getLoadProgress().setProgress(20);
			//ʼ
	        FishManager.getFishMananger().initFish();
	        LoadProgress.getLoadProgress().setProgress(40);
	        //ʼȺ
			GamingInfo.getGamingInfo().setShoalManager(new ShoalManager());
			LoadProgress.getLoadProgress().setProgress(60);     
			//ʼؿ
			GamePartManager.getManager().prepare();
			LoadProgress.getLoadProgress().setProgress(80); 
			//ʼЧ
			initSound();
	    	LoadProgress.getLoadProgress().setProgress(90);  	
			//ʼ
			CannonManager.getCannonManager().initCannon();
			LoadProgress.getLoadProgress().setProgress(100);
	}
	
	/**
	 * ֹͣϷ
	 */
	public void stop(){
		
		try {
			//Ϸ
			GamingInfo.getGamingInfo().setGaming(false);
			Thread.sleep(1000);
			//עֹ
			MusicManager.release();
			//ע
			FishManager.destroy();
			//עϷؿ
			GamePartManager.getManager().destroy();
			//עЧ
			SoundManager.release();
			//ע
			LoadProgress.getLoadProgress().destroy();
			//עԼ
			manager = null;
		} catch (Exception e) {
			LogTools.doLogForException(e);
		}
	}
	
	/**
	 * ʼϷ
	 */
	private void beginGame(){
		//ʼ
		GamePartManager.getManager().start();
	}
	
	/**
     * ʼЧ
     */
	private void initSound(){
		GamingInfo.getGamingInfo().setSoundManager(SoundManager.getSoundManager());
		
	}
}
